Code

Merge branch 'maint'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset LANGUAGE
48 unset $(perl -e '
49         my @env = keys %ENV;
50         my $ok = join("|", qw(
51                 TRACE
52                 DEBUG
53                 USE_LOOKUP
54                 TEST
55                 .*_TEST
56                 PROVE
57                 VALGRIND
58         ));
59         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
60         print join("\n", @vars);
61 ')
62 GIT_AUTHOR_EMAIL=author@example.com
63 GIT_AUTHOR_NAME='A U Thor'
64 GIT_COMMITTER_EMAIL=committer@example.com
65 GIT_COMMITTER_NAME='C O Mitter'
66 GIT_MERGE_VERBOSITY=5
67 GIT_MERGE_AUTOEDIT=no
68 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
69 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
70 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
71 export EDITOR
73 # Protect ourselves from common misconfiguration to export
74 # CDPATH into the environment
75 unset CDPATH
77 unset GREP_OPTIONS
79 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
80         1|2|true)
81                 echo "* warning: Some tests will not work if GIT_TRACE" \
82                         "is set as to trace on STDERR ! *"
83                 echo "* warning: Please set GIT_TRACE to something" \
84                         "other than 1, 2 or true ! *"
85                 ;;
86 esac
88 # Convenience
89 #
90 # A regexp to match 5 and 40 hexdigits
91 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
92 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
94 # Zero SHA-1
95 _z40=0000000000000000000000000000000000000000
97 # Line feed
98 LF='
99 '
101 # Each test should start with something like this, after copyright notices:
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
105 # '
106 # . ./test-lib.sh
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108                 TERM=$ORIGINAL_TERM &&
109                 export TERM &&
110                 [ -t 1 ] &&
111                 tput bold >/dev/null 2>&1 &&
112                 tput setaf 1 >/dev/null 2>&1 &&
113                 tput sgr0 >/dev/null 2>&1
114         ) &&
115         color=t
117 while test "$#" -ne 0
118 do
119         case "$1" in
120         -d|--d|--de|--deb|--debu|--debug)
121                 debug=t; shift ;;
122         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
123                 immediate=t; shift ;;
124         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
125                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
126         -h|--h|--he|--hel|--help)
127                 help=t; shift ;;
128         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129                 verbose=t; shift ;;
130         -q|--q|--qu|--qui|--quie|--quiet)
131                 # Ignore --quiet under a TAP::Harness. Saying how many tests
132                 # passed without the ok/not ok details is always an error.
133                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
134         --with-dashes)
135                 with_dashes=t; shift ;;
136         --no-color)
137                 color=; shift ;;
138         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139                 valgrind=t; verbose=t; shift ;;
140         --tee)
141                 shift ;; # was handled already
142         --root=*)
143                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144                 shift ;;
145         *)
146                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147         esac
148 done
150 if test -n "$color"; then
151         say_color () {
152                 (
153                 TERM=$ORIGINAL_TERM
154                 export TERM
155                 case "$1" in
156                         error) tput bold; tput setaf 1;; # bold red
157                         skip)  tput bold; tput setaf 2;; # bold green
158                         pass)  tput setaf 2;;            # green
159                         info)  tput setaf 3;;            # brown
160                         *) test -n "$quiet" && return;;
161                 esac
162                 shift
163                 printf "%s" "$*"
164                 tput sgr0
165                 echo
166                 )
167         }
168 else
169         say_color() {
170                 test -z "$1" && test -n "$quiet" && return
171                 shift
172                 echo "$*"
173         }
174 fi
176 error () {
177         say_color error "error: $*"
178         GIT_EXIT_OK=t
179         exit 1
182 say () {
183         say_color info "$*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
190 then
191         echo "$test_description"
192         exit 0
193 fi
195 exec 5>&1
196 exec 6<&0
197 if test "$verbose" = "t"
198 then
199         exec 4>&2 3>&1
200 else
201         exec 4>/dev/null 3>/dev/null
202 fi
204 test_failure=0
205 test_count=0
206 test_fixed=0
207 test_broken=0
208 test_success=0
210 test_external_has_tap=0
212 die () {
213         code=$?
214         if test -n "$GIT_EXIT_OK"
215         then
216                 exit $code
217         else
218                 echo >&5 "FATAL: Unexpected exit with code $code"
219                 exit 1
220         fi
223 GIT_EXIT_OK=
224 trap 'die' EXIT
226 # The semantics of the editor variables are that of invoking
227 # sh -c "$EDITOR \"$@\"" files ...
229 # If our trash directory contains shell metacharacters, they will be
230 # interpreted if we just set $EDITOR directly, so do a little dance with
231 # environment variables to work around this.
233 # In particular, quoting isn't enough, as the path may contain the same quote
234 # that we're using.
235 test_set_editor () {
236         FAKE_EDITOR="$1"
237         export FAKE_EDITOR
238         EDITOR='"$FAKE_EDITOR"'
239         export EDITOR
242 test_decode_color () {
243         awk '
244                 function name(n) {
245                         if (n == 0) return "RESET";
246                         if (n == 1) return "BOLD";
247                         if (n == 30) return "BLACK";
248                         if (n == 31) return "RED";
249                         if (n == 32) return "GREEN";
250                         if (n == 33) return "YELLOW";
251                         if (n == 34) return "BLUE";
252                         if (n == 35) return "MAGENTA";
253                         if (n == 36) return "CYAN";
254                         if (n == 37) return "WHITE";
255                         if (n == 40) return "BLACK";
256                         if (n == 41) return "BRED";
257                         if (n == 42) return "BGREEN";
258                         if (n == 43) return "BYELLOW";
259                         if (n == 44) return "BBLUE";
260                         if (n == 45) return "BMAGENTA";
261                         if (n == 46) return "BCYAN";
262                         if (n == 47) return "BWHITE";
263                 }
264                 {
265                         while (match($0, /\033\[[0-9;]*m/) != 0) {
266                                 printf "%s<", substr($0, 1, RSTART-1);
267                                 codes = substr($0, RSTART+2, RLENGTH-3);
268                                 if (length(codes) == 0)
269                                         printf "%s", name(0)
270                                 else {
271                                         n = split(codes, ary, ";");
272                                         sep = "";
273                                         for (i = 1; i <= n; i++) {
274                                                 printf "%s%s", sep, name(ary[i]);
275                                                 sep = ";"
276                                         }
277                                 }
278                                 printf ">";
279                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
280                         }
281                         print
282                 }
283         '
286 nul_to_q () {
287         perl -pe 'y/\000/Q/'
290 q_to_nul () {
291         perl -pe 'y/Q/\000/'
294 q_to_cr () {
295         tr Q '\015'
298 q_to_tab () {
299         tr Q '\011'
302 append_cr () {
303         sed -e 's/$/Q/' | tr Q '\015'
306 remove_cr () {
307         tr '\015' Q | sed -e 's/Q$//'
310 # In some bourne shell implementations, the "unset" builtin returns
311 # nonzero status when a variable to be unset was not set in the first
312 # place.
314 # Use sane_unset when that should not be considered an error.
316 sane_unset () {
317         unset "$@"
318         return 0
321 test_tick () {
322         if test -z "${test_tick+set}"
323         then
324                 test_tick=1112911993
325         else
326                 test_tick=$(($test_tick + 60))
327         fi
328         GIT_COMMITTER_DATE="$test_tick -0700"
329         GIT_AUTHOR_DATE="$test_tick -0700"
330         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
333 # Stop execution and start a shell. This is useful for debugging tests and
334 # only makes sense together with "-v".
336 # Be sure to remove all invocations of this command before submitting.
338 test_pause () {
339         if test "$verbose" = t; then
340                 "$SHELL_PATH" <&6 >&3 2>&4
341         else
342                 error >&5 "test_pause requires --verbose"
343         fi
346 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
348 # This will commit a file with the given contents and the given commit
349 # message.  It will also add a tag with <message> as name.
351 # Both <file> and <contents> default to <message>.
353 test_commit () {
354         file=${2:-"$1.t"}
355         echo "${3-$1}" > "$file" &&
356         git add "$file" &&
357         test_tick &&
358         git commit -m "$1" &&
359         git tag "$1"
362 # Call test_merge with the arguments "<message> <commit>", where <commit>
363 # can be a tag pointing to the commit-to-merge.
365 test_merge () {
366         test_tick &&
367         git merge -m "$1" "$2" &&
368         git tag "$1"
371 # This function helps systems where core.filemode=false is set.
372 # Use it instead of plain 'chmod +x' to set or unset the executable bit
373 # of a file in the working directory and add it to the index.
375 test_chmod () {
376         chmod "$@" &&
377         git update-index --add "--chmod=$@"
380 # Unset a configuration variable, but don't fail if it doesn't exist.
381 test_unconfig () {
382         git config --unset-all "$@"
383         config_status=$?
384         case "$config_status" in
385         5) # ok, nothing to unset
386                 config_status=0
387                 ;;
388         esac
389         return $config_status
392 # Set git config, automatically unsetting it after the test is over.
393 test_config () {
394         test_when_finished "test_unconfig '$1'" &&
395         git config "$@"
399 test_config_global () {
400         test_when_finished "test_unconfig --global '$1'" &&
401         git config --global "$@"
404 write_script () {
405         {
406                 echo "#!${2-"$SHELL_PATH"}" &&
407                 cat
408         } >"$1" &&
409         chmod +x "$1"
412 # Use test_set_prereq to tell that a particular prerequisite is available.
413 # The prerequisite can later be checked for in two ways:
415 # - Explicitly using test_have_prereq.
417 # - Implicitly by specifying the prerequisite tag in the calls to
418 #   test_expect_{success,failure,code}.
420 # The single parameter is the prerequisite tag (a simple word, in all
421 # capital letters by convention).
423 test_set_prereq () {
424         satisfied="$satisfied$1 "
426 satisfied=" "
428 test_have_prereq () {
429         # prerequisites can be concatenated with ','
430         save_IFS=$IFS
431         IFS=,
432         set -- $*
433         IFS=$save_IFS
435         total_prereq=0
436         ok_prereq=0
437         missing_prereq=
439         for prerequisite
440         do
441                 total_prereq=$(($total_prereq + 1))
442                 case $satisfied in
443                 *" $prerequisite "*)
444                         ok_prereq=$(($ok_prereq + 1))
445                         ;;
446                 *)
447                         # Keep a list of missing prerequisites
448                         if test -z "$missing_prereq"
449                         then
450                                 missing_prereq=$prerequisite
451                         else
452                                 missing_prereq="$prerequisite,$missing_prereq"
453                         fi
454                 esac
455         done
457         test $total_prereq = $ok_prereq
460 test_declared_prereq () {
461         case ",$test_prereq," in
462         *,$1,*)
463                 return 0
464                 ;;
465         esac
466         return 1
469 # You are not expected to call test_ok_ and test_failure_ directly, use
470 # the text_expect_* functions instead.
472 test_ok_ () {
473         test_success=$(($test_success + 1))
474         say_color "" "ok $test_count - $@"
477 test_failure_ () {
478         test_failure=$(($test_failure + 1))
479         say_color error "not ok - $test_count $1"
480         shift
481         echo "$@" | sed -e 's/^/#       /'
482         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
485 test_known_broken_ok_ () {
486         test_fixed=$(($test_fixed+1))
487         say_color "" "ok $test_count - $@ # TODO known breakage"
490 test_known_broken_failure_ () {
491         test_broken=$(($test_broken+1))
492         say_color skip "not ok $test_count - $@ # TODO known breakage"
495 test_debug () {
496         test "$debug" = "" || eval "$1"
499 test_eval_ () {
500         # This is a separate function because some tests use
501         # "return" to end a test_expect_success block early.
502         eval </dev/null >&3 2>&4 "$*"
505 test_run_ () {
506         test_cleanup=:
507         expecting_failure=$2
508         test_eval_ "$1"
509         eval_ret=$?
511         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
512         then
513                 test_eval_ "$test_cleanup"
514         fi
515         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
516                 echo ""
517         fi
518         return "$eval_ret"
521 test_skip () {
522         test_count=$(($test_count+1))
523         to_skip=
524         for skp in $GIT_SKIP_TESTS
525         do
526                 case $this_test.$test_count in
527                 $skp)
528                         to_skip=t
529                         break
530                 esac
531         done
532         if test -z "$to_skip" && test -n "$test_prereq" &&
533            ! test_have_prereq "$test_prereq"
534         then
535                 to_skip=t
536         fi
537         case "$to_skip" in
538         t)
539                 of_prereq=
540                 if test "$missing_prereq" != "$test_prereq"
541                 then
542                         of_prereq=" of $test_prereq"
543                 fi
545                 say_color skip >&3 "skipping test: $@"
546                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
547                 : true
548                 ;;
549         *)
550                 false
551                 ;;
552         esac
555 test_expect_failure () {
556         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
557         test "$#" = 2 ||
558         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
559         export test_prereq
560         if ! test_skip "$@"
561         then
562                 say >&3 "checking known breakage: $2"
563                 if test_run_ "$2" expecting_failure
564                 then
565                         test_known_broken_ok_ "$1"
566                 else
567                         test_known_broken_failure_ "$1"
568                 fi
569         fi
570         echo >&3 ""
573 test_expect_success () {
574         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
575         test "$#" = 2 ||
576         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
577         export test_prereq
578         if ! test_skip "$@"
579         then
580                 say >&3 "expecting success: $2"
581                 if test_run_ "$2"
582                 then
583                         test_ok_ "$1"
584                 else
585                         test_failure_ "$@"
586                 fi
587         fi
588         echo >&3 ""
591 # test_external runs external test scripts that provide continuous
592 # test output about their progress, and succeeds/fails on
593 # zero/non-zero exit code.  It outputs the test output on stdout even
594 # in non-verbose mode, and announces the external script with "# run
595 # <n>: ..." before running it.  When providing relative paths, keep in
596 # mind that all scripts run in "trash directory".
597 # Usage: test_external description command arguments...
598 # Example: test_external 'Perl API' perl ../path/to/test.pl
599 test_external () {
600         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
601         test "$#" = 3 ||
602         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
603         descr="$1"
604         shift
605         export test_prereq
606         if ! test_skip "$descr" "$@"
607         then
608                 # Announce the script to reduce confusion about the
609                 # test output that follows.
610                 say_color "" "# run $test_count: $descr ($*)"
611                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
612                 # to be able to use them in script
613                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
614                 # Run command; redirect its stderr to &4 as in
615                 # test_run_, but keep its stdout on our stdout even in
616                 # non-verbose mode.
617                 "$@" 2>&4
618                 if [ "$?" = 0 ]
619                 then
620                         if test $test_external_has_tap -eq 0; then
621                                 test_ok_ "$descr"
622                         else
623                                 say_color "" "# test_external test $descr was ok"
624                                 test_success=$(($test_success + 1))
625                         fi
626                 else
627                         if test $test_external_has_tap -eq 0; then
628                                 test_failure_ "$descr" "$@"
629                         else
630                                 say_color error "# test_external test $descr failed: $@"
631                                 test_failure=$(($test_failure + 1))
632                         fi
633                 fi
634         fi
637 # Like test_external, but in addition tests that the command generated
638 # no output on stderr.
639 test_external_without_stderr () {
640         # The temporary file has no (and must have no) security
641         # implications.
642         tmp=${TMPDIR:-/tmp}
643         stderr="$tmp/git-external-stderr.$$.tmp"
644         test_external "$@" 4> "$stderr"
645         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
646         descr="no stderr: $1"
647         shift
648         say >&3 "# expecting no stderr from previous command"
649         if [ ! -s "$stderr" ]; then
650                 rm "$stderr"
652                 if test $test_external_has_tap -eq 0; then
653                         test_ok_ "$descr"
654                 else
655                         say_color "" "# test_external_without_stderr test $descr was ok"
656                         test_success=$(($test_success + 1))
657                 fi
658         else
659                 if [ "$verbose" = t ]; then
660                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
661                 else
662                         output=
663                 fi
664                 # rm first in case test_failure exits.
665                 rm "$stderr"
666                 if test $test_external_has_tap -eq 0; then
667                         test_failure_ "$descr" "$@" "$output"
668                 else
669                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
670                         test_failure=$(($test_failure + 1))
671                 fi
672         fi
675 # debugging-friendly alternatives to "test [-f|-d|-e]"
676 # The commands test the existence or non-existence of $1. $2 can be
677 # given to provide a more precise diagnosis.
678 test_path_is_file () {
679         if ! [ -f "$1" ]
680         then
681                 echo "File $1 doesn't exist. $*"
682                 false
683         fi
686 test_path_is_dir () {
687         if ! [ -d "$1" ]
688         then
689                 echo "Directory $1 doesn't exist. $*"
690                 false
691         fi
694 test_path_is_missing () {
695         if [ -e "$1" ]
696         then
697                 echo "Path exists:"
698                 ls -ld "$1"
699                 if [ $# -ge 1 ]; then
700                         echo "$*"
701                 fi
702                 false
703         fi
706 # test_line_count checks that a file has the number of lines it
707 # ought to. For example:
709 #       test_expect_success 'produce exactly one line of output' '
710 #               do something >output &&
711 #               test_line_count = 1 output
712 #       '
714 # is like "test $(wc -l <output) = 1" except that it passes the
715 # output through when the number of lines is wrong.
717 test_line_count () {
718         if test $# != 3
719         then
720                 error "bug in the test script: not 3 parameters to test_line_count"
721         elif ! test $(wc -l <"$3") "$1" "$2"
722         then
723                 echo "test_line_count: line count for $3 !$1 $2"
724                 cat "$3"
725                 return 1
726         fi
729 # This is not among top-level (test_expect_success | test_expect_failure)
730 # but is a prefix that can be used in the test script, like:
732 #       test_expect_success 'complain and die' '
733 #           do something &&
734 #           do something else &&
735 #           test_must_fail git checkout ../outerspace
736 #       '
738 # Writing this as "! git checkout ../outerspace" is wrong, because
739 # the failure could be due to a segv.  We want a controlled failure.
741 test_must_fail () {
742         "$@"
743         exit_code=$?
744         if test $exit_code = 0; then
745                 echo >&2 "test_must_fail: command succeeded: $*"
746                 return 1
747         elif test $exit_code -gt 129 -a $exit_code -le 192; then
748                 echo >&2 "test_must_fail: died by signal: $*"
749                 return 1
750         elif test $exit_code = 127; then
751                 echo >&2 "test_must_fail: command not found: $*"
752                 return 1
753         fi
754         return 0
757 # Similar to test_must_fail, but tolerates success, too.  This is
758 # meant to be used in contexts like:
760 #       test_expect_success 'some command works without configuration' '
761 #               test_might_fail git config --unset all.configuration &&
762 #               do something
763 #       '
765 # Writing "git config --unset all.configuration || :" would be wrong,
766 # because we want to notice if it fails due to segv.
768 test_might_fail () {
769         "$@"
770         exit_code=$?
771         if test $exit_code -gt 129 -a $exit_code -le 192; then
772                 echo >&2 "test_might_fail: died by signal: $*"
773                 return 1
774         elif test $exit_code = 127; then
775                 echo >&2 "test_might_fail: command not found: $*"
776                 return 1
777         fi
778         return 0
781 # Similar to test_must_fail and test_might_fail, but check that a
782 # given command exited with a given exit code. Meant to be used as:
784 #       test_expect_success 'Merge with d/f conflicts' '
785 #               test_expect_code 1 git merge "merge msg" B master
786 #       '
788 test_expect_code () {
789         want_code=$1
790         shift
791         "$@"
792         exit_code=$?
793         if test $exit_code = $want_code
794         then
795                 return 0
796         fi
798         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
799         return 1
802 # test_cmp is a helper function to compare actual and expected output.
803 # You can use it like:
805 #       test_expect_success 'foo works' '
806 #               echo expected >expected &&
807 #               foo >actual &&
808 #               test_cmp expected actual
809 #       '
811 # This could be written as either "cmp" or "diff -u", but:
812 # - cmp's output is not nearly as easy to read as diff -u
813 # - not all diff versions understand "-u"
815 test_cmp() {
816         $GIT_TEST_CMP "$@"
819 # This function can be used to schedule some commands to be run
820 # unconditionally at the end of the test to restore sanity:
822 #       test_expect_success 'test core.capslock' '
823 #               git config core.capslock true &&
824 #               test_when_finished "git config --unset core.capslock" &&
825 #               hello world
826 #       '
828 # That would be roughly equivalent to
830 #       test_expect_success 'test core.capslock' '
831 #               git config core.capslock true &&
832 #               hello world
833 #               git config --unset core.capslock
834 #       '
836 # except that the greeting and config --unset must both succeed for
837 # the test to pass.
839 # Note that under --immediate mode, no clean-up is done to help diagnose
840 # what went wrong.
842 test_when_finished () {
843         test_cleanup="{ $*
844                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
847 # Most tests can use the created repository, but some may need to create more.
848 # Usage: test_create_repo <directory>
849 test_create_repo () {
850         test "$#" = 1 ||
851         error "bug in the test script: not 1 parameter to test-create-repo"
852         repo="$1"
853         mkdir -p "$repo"
854         (
855                 cd "$repo" || error "Cannot setup test environment"
856                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
857                 error "cannot run git init -- have you built things yet?"
858                 mv .git/hooks .git/hooks-disabled
859         ) || exit
862 test_done () {
863         GIT_EXIT_OK=t
865         if test -z "$HARNESS_ACTIVE"; then
866                 test_results_dir="$TEST_DIRECTORY/test-results"
867                 mkdir -p "$test_results_dir"
868                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
870                 cat >>"$test_results_path" <<-EOF
871                 total $test_count
872                 success $test_success
873                 fixed $test_fixed
874                 broken $test_broken
875                 failed $test_failure
877                 EOF
878         fi
880         if test "$test_fixed" != 0
881         then
882                 say_color pass "# fixed $test_fixed known breakage(s)"
883         fi
884         if test "$test_broken" != 0
885         then
886                 say_color error "# still have $test_broken known breakage(s)"
887                 msg="remaining $(($test_count-$test_broken)) test(s)"
888         else
889                 msg="$test_count test(s)"
890         fi
891         case "$test_failure" in
892         0)
893                 # Maybe print SKIP message
894                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
896                 if test $test_external_has_tap -eq 0; then
897                         say_color pass "# passed all $msg"
898                         say "1..$test_count$skip_all"
899                 fi
901                 test -d "$remove_trash" &&
902                 cd "$(dirname "$remove_trash")" &&
903                 rm -rf "$(basename "$remove_trash")"
905                 exit 0 ;;
907         *)
908                 if test $test_external_has_tap -eq 0; then
909                         say_color error "# failed $test_failure among $msg"
910                         say "1..$test_count"
911                 fi
913                 exit 1 ;;
915         esac
918 # Test the binaries we have just built.  The tests are kept in
919 # t/ subdirectory and are run in 'trash directory' subdirectory.
920 if test -z "$TEST_DIRECTORY"
921 then
922         # We allow tests to override this, in case they want to run tests
923         # outside of t/, e.g. for running tests on the test library
924         # itself.
925         TEST_DIRECTORY=$(pwd)
926 fi
927 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
929 if test -n "$valgrind"
930 then
931         make_symlink () {
932                 test -h "$2" &&
933                 test "$1" = "$(readlink "$2")" || {
934                         # be super paranoid
935                         if mkdir "$2".lock
936                         then
937                                 rm -f "$2" &&
938                                 ln -s "$1" "$2" &&
939                                 rm -r "$2".lock
940                         else
941                                 while test -d "$2".lock
942                                 do
943                                         say "Waiting for lock on $2."
944                                         sleep 1
945                                 done
946                         fi
947                 }
948         }
950         make_valgrind_symlink () {
951                 # handle only executables, unless they are shell libraries that
952                 # need to be in the exec-path.  We will just use "#!" as a
953                 # guess for a shell-script, since we have no idea what the user
954                 # may have configured as the shell path.
955                 test -x "$1" ||
956                 test "#!" = "$(head -c 2 <"$1")" ||
957                 return;
959                 base=$(basename "$1")
960                 symlink_target=$GIT_BUILD_DIR/$base
961                 # do not override scripts
962                 if test -x "$symlink_target" &&
963                     test ! -d "$symlink_target" &&
964                     test "#!" != "$(head -c 2 < "$symlink_target")"
965                 then
966                         symlink_target=../valgrind.sh
967                 fi
968                 case "$base" in
969                 *.sh|*.perl)
970                         symlink_target=../unprocessed-script
971                 esac
972                 # create the link, or replace it if it is out of date
973                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
974         }
976         # override all git executables in TEST_DIRECTORY/..
977         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
978         mkdir -p "$GIT_VALGRIND"/bin
979         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
980         do
981                 make_valgrind_symlink $file
982         done
983         # special-case the mergetools loadables
984         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
985         OLDIFS=$IFS
986         IFS=:
987         for path in $PATH
988         do
989                 ls "$path"/git-* 2> /dev/null |
990                 while read file
991                 do
992                         make_valgrind_symlink "$file"
993                 done
994         done
995         IFS=$OLDIFS
996         PATH=$GIT_VALGRIND/bin:$PATH
997         GIT_EXEC_PATH=$GIT_VALGRIND/bin
998         export GIT_VALGRIND
999 elif test -n "$GIT_TEST_INSTALLED" ; then
1000         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1001         error "Cannot run git from $GIT_TEST_INSTALLED."
1002         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
1003         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1004 else # normal case, use ../bin-wrappers only unless $with_dashes:
1005         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1006         if ! test -x "$git_bin_dir/git" ; then
1007                 if test -z "$with_dashes" ; then
1008                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1009                 fi
1010                 with_dashes=t
1011         fi
1012         PATH="$git_bin_dir:$PATH"
1013         GIT_EXEC_PATH=$GIT_BUILD_DIR
1014         if test -n "$with_dashes" ; then
1015                 PATH="$GIT_BUILD_DIR:$PATH"
1016         fi
1017 fi
1018 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1019 unset GIT_CONFIG
1020 GIT_CONFIG_NOSYSTEM=1
1021 GIT_ATTR_NOSYSTEM=1
1022 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1024 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1026 if test -z "$GIT_TEST_CMP"
1027 then
1028         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1029         then
1030                 GIT_TEST_CMP="$DIFF -c"
1031         else
1032                 GIT_TEST_CMP="$DIFF -u"
1033         fi
1034 fi
1036 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1037 export GITPERLLIB
1038 test -d "$GIT_BUILD_DIR"/templates/blt || {
1039         error "You haven't built things yet, have you?"
1042 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1043 then
1044         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1045         export GITPYTHONLIB
1046         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1047                 error "You haven't built git_remote_helpers yet, have you?"
1048         }
1049 fi
1051 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1052         echo >&2 'You need to build test-chmtime:'
1053         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1054         exit 1
1055 fi
1057 # Test repository
1058 test="trash directory.$(basename "$0" .sh)"
1059 test -n "$root" && test="$root/$test"
1060 case "$test" in
1061 /*) TRASH_DIRECTORY="$test" ;;
1062  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1063 esac
1064 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1065 rm -fr "$test" || {
1066         GIT_EXIT_OK=t
1067         echo >&5 "FATAL: Cannot prepare test area"
1068         exit 1
1071 HOME="$TRASH_DIRECTORY"
1072 export HOME
1074 test_create_repo "$test"
1075 # Use -P to resolve symlinks in our working directory so that the cwd
1076 # in subprocesses like git equals our $PWD (for pathname comparisons).
1077 cd -P "$test" || exit 1
1079 this_test=${0##*/}
1080 this_test=${this_test%%-*}
1081 for skp in $GIT_SKIP_TESTS
1082 do
1083         case "$this_test" in
1084         $skp)
1085                 say_color skip >&3 "skipping test $this_test altogether"
1086                 skip_all="skip all tests in $this_test"
1087                 test_done
1088         esac
1089 done
1091 # Provide an implementation of the 'yes' utility
1092 yes () {
1093         if test $# = 0
1094         then
1095                 y=y
1096         else
1097                 y="$*"
1098         fi
1100         while echo "$y"
1101         do
1102                 :
1103         done
1106 # Fix some commands on Windows
1107 case $(uname -s) in
1108 *MINGW*)
1109         # Windows has its own (incompatible) sort and find
1110         sort () {
1111                 /usr/bin/sort "$@"
1112         }
1113         find () {
1114                 /usr/bin/find "$@"
1115         }
1116         sum () {
1117                 md5sum "$@"
1118         }
1119         # git sees Windows-style pwd
1120         pwd () {
1121                 builtin pwd -W
1122         }
1123         # no POSIX permissions
1124         # backslashes in pathspec are converted to '/'
1125         # exec does not inherit the PID
1126         test_set_prereq MINGW
1127         test_set_prereq SED_STRIPS_CR
1128         ;;
1129 *CYGWIN*)
1130         test_set_prereq POSIXPERM
1131         test_set_prereq EXECKEEPSPID
1132         test_set_prereq NOT_MINGW
1133         test_set_prereq SED_STRIPS_CR
1134         ;;
1135 *)
1136         test_set_prereq POSIXPERM
1137         test_set_prereq BSLASHPSPEC
1138         test_set_prereq EXECKEEPSPID
1139         test_set_prereq NOT_MINGW
1140         ;;
1141 esac
1143 test -z "$NO_PERL" && test_set_prereq PERL
1144 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1145 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1146 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1148 # Can we rely on git's output in the C locale?
1149 if test -n "$GETTEXT_POISON"
1150 then
1151         GIT_GETTEXT_POISON=YesPlease
1152         export GIT_GETTEXT_POISON
1153         test_set_prereq GETTEXT_POISON
1154 else
1155         test_set_prereq C_LOCALE_OUTPUT
1156 fi
1158 # Use this instead of test_cmp to compare files that contain expected and
1159 # actual output from git commands that can be translated.  When running
1160 # under GETTEXT_POISON this pretends that the command produced expected
1161 # results.
1162 test_i18ncmp () {
1163         test -n "$GETTEXT_POISON" || test_cmp "$@"
1166 # Use this instead of "grep expected-string actual" to see if the
1167 # output from a git command that can be translated either contains an
1168 # expected string, or does not contain an unwanted one.  When running
1169 # under GETTEXT_POISON this pretends that the command produced expected
1170 # results.
1171 test_i18ngrep () {
1172         if test -n "$GETTEXT_POISON"
1173         then
1174             : # pretend success
1175         elif test "x!" = "x$1"
1176         then
1177                 shift
1178                 ! grep "$@"
1179         else
1180                 grep "$@"
1181         fi
1184 # test whether the filesystem supports symbolic links
1185 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1186 rm -f y
1188 # When the tests are run as root, permission tests will report that
1189 # things are writable when they shouldn't be.
1190 test -w / || test_set_prereq SANITY